import 'package:flutter_test/flutter_test.dart';
import 'package:get/get.dart';

abstract class Service {
  Map<String, String> post(int i);
}

class Api implements Service {
  @override
  Map<String, String> post(int i) {
    if (i == 0) {
      return {"Api_status": "200"};
    } else if (i == 1) {
      return {"Api_status": "400"};
    } else {
      return null;
    }
  }
}

class Api2 implements Service {
  @override
  Map<String, String> post(int i) {
    if (i == 0) {
      return {"Api_status": "200"};
    } else if (i == 1) {
      return {"Api_status": "400"};
    } else {
      return null;
    }
  }
}

class Controller extends GetController {
  Map<String, String> data;
  void getData(int i) {
    data = Get.find<Service>().post(i);
  }
}

funcao() {
  print('catofla');
  // await Future.delayed(Duration(seconds: 3));
  return Api2();
}

void main() {
  Get.lazyPutBuilder<Service>(funcao);
  Get.lazyPut<Controller>(Controller());

  test('Test 1', () {
    Get.lazyPut(() {});
    var service = Get.find<Service>();
    expect(service.post(0), {"Api_status": "200"});
    expect(service.post(1), {"Api_status": "400"});
    expect(service.post(2), null);
  });

  test('Test 2', () {
    var controller = Get.find<Controller>();
    controller.getData(0);
    expect(controller.data, {"Api_status": "200"});
    controller.getData(1);
    expect(controller.data, {"Api_status": "400"});
    controller.getData(2);
    expect(controller.data, null);
  });
}
